<?php
/**
 * DeubertIt
 *
 * LICENSE: Redistribution and use in source and binary forms, with or without
 * modifications, are not permitted.
 *
 * @copyright Deubert IT-Solutions © 2020 All rights reserved
 * @package DeubertIt\ElasticApmDoctrine
 */

namespace DeubertIt\ElasticApmDoctrine;

use PhilKra\Events\Transaction;

/**
 * Class Bootstrap
 * @package DeubertIt\ElasticApmDoctrine
 *
 * @author Ivan Petrov <ivan.petrov@deubert.it>
 */
class Bootstrap
{
    /**
     * @var Transaction
     */
    protected static $transactions;

    /**
     * @var bool
     */
    protected static $attached = false;

    /**
     * @return bool
     */
    public static function isAttached()
    {
        return self::$attached;
    }

    public static function attach()
    {
        self::$attached = true;
        ElasticApmDoctrine::enable();
    }

    public static function detach()
    {
        self::$attached = false;
        ElasticApmDoctrine::disable();
    }
}
