<?php
/**
 * DeubertIt
 *
 * LICENSE: Redistribution and use in source and binary forms, with or without
 * modifications, are not permitted.
 *
 * @copyright Deubert IT-Solutions © 2016 All rights reserved
 * @package DeubertIt\ElasticApmDoctrine
 */

namespace DeubertIt\ElasticApmDoctrine\Tests\Listener;

use DeubertIt\ElasticApmDoctrine\Listener\ElasticApmDoctrineListener;
use DeubertIt\ElasticApmDoctrine\Tests\TestCase;
use PHPUnit\Framework\MockObject\MockObject;

/**
 * Class EventContext
 * @package DeubertIt\ElasticApmDoctrine\Tests\Listener
 *
 * @author Ivan Petrov <ivan.petrov@deubert.it>
 */
class ElasticApmDoctrineListenerTests extends TestCase
{
    public function testListen()
    {
        /** @var \Doctrine_Connection $connectionMock */
        $connectionMock = $this->getMockBuilder(\Doctrine_Connection_Mysql::class)
            ->disableOriginalConstructor()
            ->getMock();
        $connectionMock->method('getName')->willReturn('testing-default');

        /** @var MockObject|\Doctrine_Manager $managerMock */
        $managerMock = $this->getMockBuilder(\Doctrine_Manager::class)
            ->disableOriginalConstructor()
            ->getMock();
        $managerMock->method('count')->willReturn(1);
        $managerMock->method('getIterator')->willReturn([$connectionMock]);

        ElasticApmDoctrineListener::listen(['manager' => $managerMock]);
        $this->assertTrue(ElasticApmDoctrineListener::isListening());

        $profilers = ElasticApmDoctrineListener::getProfilers();
        $this->assertCount(1, $profilers);
    }
}
